
{$APPTYPE GUI}{$MODE DELPHI}

program demo34;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Sound;

//const
 
//type
  
var 
  i:integer;
  SoundOnOFF:array[0..10]of boolean;
  
  PlayerPos: array[0..2]of ALfloat = (0,0,4); 
  PlayerVel: array[0..2]of ALfloat = (0,0,0); 
  PlayerOri: array[0..5]of ALfloat = (0,0,-1,0,1,0); 
  
  Source0Pos: array[0..2]of ALfloat = (-2,0,0); 
  Source0Vel: array[0..2]of ALfloat = (0,0,0); 

  Source1Pos: array[0..2]of ALfloat = (0,0,-2.5); 
  Source1Vel: array[0..2]of ALfloat = (0,0,0); 
  
  Source2Pos: array[0..2]of ALfloat = (2,0,0); 
  Source2Vel: array[0..2]of ALfloat = (0,0,0); 
  
  buffer: array[0..3]of ALuint; 
  source: array[0..3]of ALuint; 
  GLwin: integer; 
  size: ALsizei; 
  freq: ALsizei; 
  format: ALenum; 
  data: ALvoid; 
    
//{$R *.rc}
//{$R *.res}  

procedure init;  
begin
  if InitSound3D(
  glvector(PlayerPos[0],PlayerPos[1],PlayerPos[2]),
  glvector(PlayerVel[0],PlayerVel[1],PlayerVel[2]),
  glvector(PlayerOri[0],PlayerOri[1],PlayerOri[2]),
  glvector(PlayerOri[3],PlayerOri[4],PlayerOri[5]))then
  begin
    LoadSound3D('NoSegnaleB.wav',buffer[0]);
    LoadSound3D('plane01.wav',buffer[1]);  
    LoadSound3D('explosion.wav',buffer[2]);
    LoadSound3D('passi.wav',buffer[3]);	 

    CreateSourceSound3D(glvector(Source0Pos[0],Source0Pos[1],Source0Pos[2]),
                        glvector(Source0Vel[0],Source0Vel[1],Source0Vel[2]),buffer[0],source[0],true);
    CreateSourceSound3D(glvector(Source1Pos[0],Source1Pos[1],Source1Pos[2]),
                        glvector(Source1Vel[0],Source1Vel[1],Source1Vel[2]),buffer[1],source[1],true);  
    CreateSourceSound3D(glvector(Source2Pos[0],Source2Pos[1],Source2Pos[2]),
                        glvector(Source2Vel[0],Source2Vel[1],Source2Vel[2]),buffer[2],source[2],true);  
    CreateSourceSound3D(glvector(PlayerPos[0],PlayerPos[1],PlayerPos[2]),
                        glvector(PlayerVel[0],PlayerVel[1],PlayerVel[2]),buffer[3],source[3],true);  								
  end;
end;
  
  
procedure DeInit; 
begin
  UnLoadSound3D(buffer[0]);
  UnLoadSound3D(buffer[1]);
  UnLoadSound3D(buffer[2]);
  UnLoadSound3D(buffer[3]);
  
  DestroySourceSound3D(source[0]);  
  DestroySourceSound3D(source[1]); 
  DestroySourceSound3D(source[2]); 
  DestroySourceSound3D(source[3]);  
  
  DeInitSound3D; 
end;  


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
end;
begin 

  OpenGL_Texture(); 

  init;  
  
  PlaySound3D(source[3]);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
 
  if SetglKey('1')then begin SoundOnOFF[0]:=not(SoundOnOFF[0]);PlaySound3D(source[0]);end;
  if SetglKey('2')then begin SoundOnOFF[1]:=not(SoundOnOFF[1]);PlaySound3D(source[1]);end;
  if SetglKey('3')then begin SoundOnOFF[2]:=not(SoundOnOFF[2]);PlaySound3D(source[2]);end; 

  for i:=0 to 2 do
  if not SoundOnOFF[i]then StopSound3D(source[i]);
  
  if SetglKey(VK_LEFT)then 
  begin
    PlayerPos[0]:=PlayerPos[0]-0.1; 
    SetMyPosSound3D(glvector(PlayerPos[0],0,0));	
	ReplaySound3D(source[3]);
  end;
  if SetglKey(VK_RIGHT)then 
  begin
    PlayerPos[0]:=PlayerPos[0]+0.1; 
    SetMyPosSound3D(glvector(PlayerPos[0],0,0));	
	ReplaySound3D(source[3]);
  end;
  if SetglKey(VK_UP)then 
  begin
    PlayerPos[2]:=PlayerPos[2]-0.1; 
    SetMyPosSound3D(glvector(0,0,PlayerPos[2]));	
	ReplaySound3D(source[3]);
  end;
  if SetglKey(VK_DOWN)then 
  begin
    PlayerPos[2]:=PlayerPos[2]+0.1; 
    SetMyPosSound3D(glvector(0,0,PlayerPos[2]));	
	ReplaySound3D(source[3]);
  end;  
 
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-10);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(20,1,1,0);
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0,0,10,0,0.1);       

  // terreno
  cubo(0,-0.5,0, 6,0.1,6);   
  
  // posizioni dei suoni
  glPushMatrix; 
  glTranslatef(Source0Pos[0],Source0Pos[1],Source0Pos[2]); 
  sfera(0,0,0, 0.25,32);  
  glPopMatrix; 
  glPushMatrix; 
  
  glTranslatef(Source1Pos[0],Source1Pos[1],Source1Pos[2]); 
  sfera(0,0,0, 0.25,32);   
  glPopMatrix; 
  glPushMatrix;   
  
  glTranslatef(Source2Pos[0],Source2Pos[1],Source2Pos[2]); 
  sfera(0,0,0, 0.25,32);  
  glPopMatrix; 
  glPushMatrix; 
  
  // posizione dell'ascoltatore
  glTranslatef(PlayerPos[0],PlayerPos[1],PlayerPos[2]); 
  cubo(0,0,0, 0.25,0.25,0.25); 
  glPopMatrix; 
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di audio 3D con OpenAL', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

  DeInit; 
  DeleteOGLWindow();		    // chiude la finestra
end.
